#!/usr/local/bin/perl
###################################################################################
#
# Multi-Logger v.1b
# by Kevin Lux <webmaster@DataDragon.com>
#
# This script will log hits to various pages and show totals for the day, week, month,
# year to date and the previous day, week, month.
#
#
# Datafile view
# alias=day,prevday,week,prevweek,month,prevmonth,ytd
$datafile = "/path/to/your/www/dd-logs/multi-log";

if (!$ENV{'QUERY_STRING'}) {
	$action=shift(@ARGV);
	$actionvar=shift(@ARGV);
} else {
	($action, $actionvar) = split(/,/,$ENV{'QUERY_STRING'});
}

if ($action eq "add") {
	
	$alias = $actionvar;
	$realname = "@ARGV";
	if ((!$realname) || (!$alias)) {
		die "\n\nUsage: $0 add alias realname\n\n";
	} 
	$fileline = "$actionvar:0,0,0,0,0,0,0,$realname\n";
	open(DATAFILE, ">>$datafile");
	print DATAFILE $fileline;
	close(DATAFILE);

}

if ($action eq "init") {
	
	open(DATAFILE,">$datafile");
	print DATAFILE "0,0,0,0\n";
	close(DATAFILE);

}

if ($action eq "log") {

	open(DATAFILE, $datafile); #Open the log file and parse into associative array
	flock(DATAFILE,2);
        
	$lastdate = <DATAFILE>;
	chop($lastdate);
	($lastday, $lastweek, $lastmonth, $lastyear) = split(/,/,$lastdate);
	
	$currday  = `date +"%j"`;
	chop($currday);
	$currweek = `date +"%W"`;
	chop($currweek);
	$currmonth= `date +"%m"`;
	chop($currmonth);
	$curryear = `date +"%Y"`;
	chop($curryear);

	while (<DATAFILE>) {
                chop;
                ($tname,$tpw) = split(':',$_);
                $File{$tname} = $tpw;
        }
	
	close(DATAFILE);
	if (!$File{$actionvar}) {
		print "Content-type: text/html\n\n";
		print "That alias is not defined in multi-log.\n";
	}

	($day, $prevday, $week, $prevweek, $month, $prevmonth, $ytd, $realname) = split(/,/,$File{$actionvar});
	
	if ($currday eq $lastday) {
		#everything was moved.
		$day++;
		$week++;
		$month++;
		$ytd++;
	} else {
		
		if ($currday ne $lastday) {
			$lastday = $currday;
			$prevday = $day;
			$day     = 1;
			$chday=1;
		} 			
 
		if ($currweek ne $lastweek) {
			$lastweek = $currwek;
			$prevweek = $week;
			$week     = 1;
			$chweek   = 1;
		} else {
			$week++;
		}
		
		if ($currmonth ne $lastmonth) {
			$lastmonth = $currmonth;
			$prevmonth = $month;
			$month     = 1;
			$chmonth   = 1;
		} else {
			$month++;
		}

		if ($curryear ne $lastyear) {
			$ytd     = 1;
			$chyear  = 1;
		} else {
			$ytd++;
		}
	}
	
	$dateline = "$currday,$currweek,$currmonth,$curryear\n";
	$File{$actionvar} = "$day,$prevday,$week,$prevweek,$month,$prevmonth,$ytd,$realname";
	
	#update the file.
	flock(DATAFILE,8);
	close(DATAFILE);
	open(DATAFILE, 	">$datafile");
	flock(DATAFILE,2);
	print DATAFILE $dateline;
	foreach $action (keys(%File)) {
		if ($action eq $actionvar) {
			#print that line, as it is the one that was updated.
			print DATAFILE "$action:$File{$action}\n";
		} else {
			#if there were no updates, just print the line, else
			#we have to update them.
			if ((!$chday) && (!$chweek) && (!$chmonth) && (!$chyear)) {
				print DATAFILE "$action:$File{$action}\n";
			} else {
				($day, $prevday, $week, $prevweek, $month, $prevmonth, $ytd, $realname) = split(/,/,$File{$action});
		
				if ($chday) {
					$prevday = $day;
					$day = 0;
				}
				if ($chweek) {
					$prevweek = $week;
					$week = 0;
				}
				if ($chmonth) {
					$prevmonth = $month;
					$month = 0;
				}
				if ($chyear) {
					$ytd = 0;
				}
				$File{$action} = "$day,$prevday,$week,$prevweek,$month,$prevmonth,$ytd,$realname";
				print DATAFILE "$action:$File{$action}\n";
			}		
		}
	}
	flock(DATAFILE,8);
	close(DATAFILE);
	print "Content-type: text/html\n\n";
	
}

if ($action eq "show") {
	open(DATAFILE, $datafile); #Open the log file and parse into associative array
        
	$lastdate = <DATAFILE>;

	while (<DATAFILE>) {
                chop;
                ($tname,$tpw) = split(':',$_);
                $File{$tname} = $tpw;
        }

	$bfont = "<font face=arial size=-1>";
	$efont = "</font>";
	$hfont = "<font face=arial color=ffffff>";
	$bb = "<b>";
	$eb = "</b>";
	print "Content-type: text/html\n\n<table border=1 cellpadding=5><tr valign=bottom bgcolor=000066><td>$hfont$bb Section$eb$efont</td><td>$hfont$bb Hits<br>Today$eb$efont</td>";
	print "<td>$hfont$bb Hits<br>Yesterday$eb$efont</td><td>$hfont$bb This<br>Week$eb$efont</td>";
	print "<td>$hfont$bb Last<br>Week$eb$efont</td><td>$hfont$bb This<br>Month$eb$efont</td>";
	print "<td>$hfont$bb Last<br>Month$eb$efont</td><td>$hfont$bb Year to<br>Date$eb$efont</td></tr>";
	$x = 1;
	foreach $key (sort(%File)) {
		if (!(length($File{$key}) < 5)) {
		($day, $prevday, $week, $prevweek, $month, $prevmonth, $ytd, $realname) = split(/,/,$File{$key});
		if ($x eq 1) {
			print "<tr bgcolor=ffffcc>";
			$x = 2;
		} else {
			print "<tr bgcolor=ffff99>";
			$x = 1;
		}
		print "<td>$realname</td><td>$day</td><td>$prevday</td><td>$week</td><td>$prevweek</td>";
		print "<td>$month</td><td>$prevmonth</td><td>$ytd</td></tr>";
		}

	}
		print "</table>";
}	

	 